unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OleCtrls, SHDocVw, StdCtrls, mshtml, strutils, ExtCtrls, Buttons, Menus,
  AxCtrls, VCF1, OleServer, Grids, CoolTrayIcon, ImgList;

const
  CM_RESTORE = WM_USER + $1000;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    Panel1: TPanel;
    Label1: TLabel;
    Timer1: TTimer;
    Label2: TLabel;
    Panel2: TPanel;
    Panel3: TPanel;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    ListBox1: TListBox;
    Timer2: TTimer;
    l0: TLabel;
    l1: TLabel;
    l2: TLabel;
    l3: TLabel;
    l4: TLabel;
    StringGrid1: TStringGrid;
    p0: TLabel;
    p1: TLabel;
    p2: TLabel;
    p3: TLabel;
    p4: TLabel;
    N3: TMenuItem;
    Timer3: TTimer;
    TrayIcon1: TCoolTrayIcon;
    ImageList2: TImageList;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure WebBrowser1DocumentComplete(Sender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
    procedure N2Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure start();
    procedure display();
    procedure stockclear();
    procedure Timer3Timer(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
    procedure CreateParams(var Params: TCreateParams); override;
    procedure RestoreRequest(var message: TMessage); message CM_RESTORE;
  end;

var
  Form1: TForm1;
  s1, ss,a2: string;

implementation

uses Unit2,MsgFrm;

{$R *.DFM}
procedure Tform1.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  Params.WinClassName := 'stockview';
end;

procedure Tform1.RestoreRequest(var message: TMessage);
begin
  if IsIconic(Application.Handle) = TRUE then
    Application.Restore
  else
    Application.BringToFront;
end;

procedure Parser(Source,Target:TStrings);
var i,j:integer;
   s:String;
   ws:wideString;
   InCmd,InStr,CmdOK:boolean;
   CmdType,StrType:String;
   CmdData,StrData:String;
   Data:String;
begin
  Target.Clear;
  InCmd:=false;
  InStr:=False;
  CmdOk:=false;
  CmdType:='';
  StrType:='';
  CmdData:='';
  StrData:='';
  data:='';
  for i:=0 to source.count-1 do
  begin
    ws:=source[i];
    for j:=1 to length(ws) do
    begin
      s:=ws[j];
      if s<' ' then continue;
      
      if InCmd then
      begin
        if InStr then
        begin
          if s=StrType then
          begin
            CmdData:=CmdData+StrType+StrData+StrType;
            InStr:=False;
            StrType:='';
            StrData:='';
          end
          else
          begin
            StrData:=StrData+s;
          end;
        end
        else if (s='"') or (s='''') then
        begin
           InStr:=True;
           StrData:='';
           StrType:=s;
        end
        else if s='>' then
        begin
           Target.add('<'+CmdType+' '+CmdData+'>');
           InCmd:=false;
           CmdType:='';
           CmdData:='';
           CmdOk:=false;
        end
        else if not CmdOK then
        begin
           if s=' ' then
           begin
             CmdOK:=True;
             CmdData:='';
           end
           else
           begin
              CmdType:=CmdType+s;
           end;
        end
        else
        begin
           CmdData:=CmdData+s;
        end;
      end
      else
      begin
        if s='<' then
        begin
           if data<>'' then target.add(data);
           data:='';
           InCmd:=true;
           CmdType:='';
           CmdData:='';
           CmdOk:=false;
        end
        else
        begin
          data:=data+s;
        end;
      end;
    end;
  end;
  if data<>'' then target.add(data);
end;
procedure HtmlTable2StringGrid(Target:TStrings;HeadFieldTitle:String;StringGrid:TStringGrid);
var InTable:integer;
  InTr:boolean;
  InTd:boolean;
  InData:boolean;
  DataRow,DataCol:integer;
  X,Y:integer;
  i,j:integer;
  ColCount:integer;
  InHead:Boolean;
  s:String;
begin
  StringGrid.FixedCols:=1;
  StringGrid.FixedRows:=1;
  StringGrid.rowcount:=2;
  StringGrid.colcount:=2;
  StringGrid.cells[0,0]:='';
  StringGrid.cells[0,1]:='';
  StringGrid.cells[1,0]:='';
  StringGrid.cells[1,1]:='';
  InTable:=0;
  InData:=false;
  inTr:=false;
  InTd:=False;
  DataRow:=0;
  DataCol:=0;
  ColCount:=0;
  InHead:=false;
  for i:=0 to Target.count-1 do
  begin
    s:=Target[i];
    if upperCase(copy(s,1,7))='<TABLE ' then
    begin
      InTable:=InTable+1;
      inTr:=false;
      InTd:=False;
      DataRow:=0;
      DataCol:=0;
      InData:=false;
    end
    else if upperCase(copy(s,1,8))='</TABLE ' then
    begin
      InTable:=InTable-1;
      inTr:=false;
      InTd:=False;
      DataRow:=0;
      DataCol:=0;
      InData:=false;
    end
    else if InTable>0 then
    begin
       if (upperCase(copy(s,1,4))='<TR ')  then
       begin
         InTr:=true;
         InTd:=False;
         DataCol:=0;
         DataRow:=DataRow+1;
         if InData Then
         begin
           if StringGrid.rowcount<DataRow then
           begin
             StringGrid.rowcount:=DataRow;
           end;
           for j:=0 to StringGrid.ColCount-1 do
             StringGrid.Cells[j,StringGrid.rowcount-1]:='';
         end;
         InHead:=true;
       end
       else if (upperCase(copy(s,1,5))='</TR ') then
       begin
         InTr:=False;
         InTd:=False;
         DataCol:=0;
         InHead:=true;
       end
       else if InTr then
       begin
         if (upperCase(copy(s,1,4))='<TD ') or (upperCase(copy(s,1,4))='<TH ') then
         begin
           InTd:=True;
           DataCol:=DataCol+1;
           if InData Then
           begin
             if StringGrid.Colcount<DataCol then
             begin
               StringGrid.Colcount:=DataCol;
             end;
             for j:=0 to StringGrid.RowCount-1 do
               StringGrid.Cells[StringGrid.colcount-1,j]:='';
           end;
         end
         else if (upperCase(copy(s,1,5))='</TD ') or (upperCase(copy(s,1,5))='</TH ') then
         begin
           InTd:=False;
         end
         else if InTd then
         begin
            if copy(s,1,1)='<' then
            else if not InData then
            begin
               if s=HeadFieldTitle then
               begin
                 InData:=True;
                 InHead:=true;
                 DataRow:=1;
                 for j:=0 to StringGrid.ColCount-1 do
                    StringGrid.Cells[j,StringGrid.rowcount-1]:='';
                 StringGrid.Cells[DataCol-1,DataRow-1]:=s;
               end;
            end
            else if inData then
            begin
               s:=trim(s);
               if s<>'' then
               begin
               if StringGrid.Cells[DataCol-1,DataRow-1]<>'' then
                 StringGrid.Cells[DataCol-1,DataRow-1]:=StringGrid.Cells[DataCol-1,DataRow-1]+','+s
               else
                 StringGrid.Cells[DataCol-1,DataRow-1]:=StringGrid.Cells[DataCol-1,DataRow-1]+s;
               end;
            end;
         end;
       end;
    end;
  end;
end;


procedure tform1.display();
var i: integer; lb,ll: tlabel; w:string;
begin
  for i := 0 to form1.listbox1.Items.Count - 1 do
  begin
    lb := findcomponent('p' + inttostr(i)) as tlabel;
    ll := findcomponent('l' + inttostr(i)) as Tlabel;
    lb.caption:=stringgrid1.Cells[1,i+1];
    w:=midstr(stringgrid1.Cells[7,i+1],1,1);
    ll.Caption:=(stringgrid1.Cells[5,i+1])+(stringgrid1.Cells[7,i+1]);
    if w='' then
    ll.Font.Color:=clLime
    else
    if w='' then
    ll.Font.Color:=clRed
    else
    ll.Font.Color:=clWhite;
  end;
end;

procedure tform1.start();
var i: integer;
begin
  for i := 0 to form1.listbox1.Items.Count - 1 do
  begin
    a2 := LeftStr((form1.listbox1.Items.Strings[i]), 4);
    s1 := s1 + '&&=' + a2;
  end;
  delete(s1,1,3);
  webbrowser1.Navigate('http://210.59.194.20/www/kline/blue_likea.cgi?='+s1);
  ss:='';
  s1 := '';
end;

procedure TForm1.FormCreate(Sender: TObject);
var i: integer;
begin
  label2.Caption := datetostr(now);
  listbox1.Items.loadfromFile('rec.ini');
  form1.start;
  timer3.Enabled:=true;
  Application.Minimize;      // Will hide dialogs and popup windows as well (this demo has none)
  TrayIcon1.HideMainForm;
  TrayIcon1.IconList := ImageList2;
  TrayIcon1.CycleInterval := 400;
  TrayIcon1.CycleIcons := True;
  TrayIcon1.HideTaskbarIcon;  
end;


procedure TForm1.Timer1Timer(Sender: TObject);
begin
  label1.Caption := timetostr(now);
end;



procedure TForm1.WebBrowser1DocumentComplete(Sender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
  var Source,Target:TStringList;
begin
  Source:=TStringList.create;
  Target:=TStringList.create;
  Source.add((webbrowser1.Document as IHtmlDocument2).Body.innerhtml);
  Parser(Source,Target);
  HtmlTable2StringGrid(Target,ss,StringGrid1);
  Source.free;
  Target.free;
  stockclear;
  display;
end;

procedure TForm1.N2Click(Sender: TObject);
begin
  form1.Close;
end;

procedure TForm1.N1Click(Sender: TObject);
begin
  form2.ShowModal;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
  form1.start;
end;

procedure Tform1.stockclear();
var i: integer; lb,ll: tlabel;
begin
  for i := 0 to 4 do
  begin
    lb := findcomponent('p' + inttostr(i)) as tlabel;
    ll := findcomponent('l' + inttostr(i)) as Tlabel;
    lb.Caption :='';
    ll.Caption :='';
  end;
end;


procedure TForm1.Timer3Timer(Sender: TObject);
var kind:Tmsgkind;
begin
timer3.Interval:=timer3.Interval+100;
if timer3.Interval=2500 then
begin
  showDelay:=1;
  showpos:= spLeft;
  showmsg(l0.Caption,mkInfo);
  timer3.interval:=100;
end;

end;

end.

